/*
IRC-Transport control.c: To Stop the transport "nicely" =]
Copyright (C) 1999-2000 Keith Minkler <tsbandit@jabber.org>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You can reach The author at tsbandit@jabber.org (email or jid)
*/

#include <irctrans.h>
extern session sessions;

/*
used to exit the server and close down all session gracefully
*/
int irc_trans_stop(void)
/*
returns:
  0 always
input:
  none
*/
{
    int sleep_flag=0;
    session loop;
    pth_mutex_acquire(&s__m,0,NULL);
    loop = sessions;
    while(loop!=NULL)
    {
        irc_send_message(loop,NULL,NULL,"groupchat","IRC Transport has been shut down, Please try to reconnect later",NULL);
        if(loop->rc)
        { /* this item has active locks */
            log_error(ZONE,"[IRC] (%s)[%s] still active, pausing 10 seconds to wait for a quit", jid_full(loop->j),loop->server);
            loop->rc = 0; /* clearing the locks causes the session to end */
            session_unlink(loop);
            sleep_flag++;
        }
        loop = loop->next;
    }
    if(sleep_flag!=0)
        pth_sleep(10);
    pth_mutex_release(&s__m);
    return 0;
}
